<?php

  // bibliothques
  require_once 'pear/DB.php';

  class impots_data{  
    // classe d'accs  la source de donnes DBIMPOTS

  	// attributs
    var $sDSN;					// la chane de connexion
  	var $sDatabase;			// le nom de la base
    var $oDB;						// connexion  la base
    var $aErreurs;			// liste d'erreurs
    var $oRsultats;		// rsultat d'une requte
		var $connect;			// boolen qui indique si on est connect ou non  la base
		var $sQuery;				// la dernire requte excute

    // constructeur
    function impots_data($dDSN){

    	// $dDSN : dictionnaire dfinissant la liaison  tablir
      // $dDSN['sgbd'] : le type du SGBD auquel il faut se connecter
      // $dDSN['host'] : le nom de la machine hte qui l'hberge      
      // $dDSN['database'] : le nom de la base  laquelle il faut se connecter      
      // $dDSN['user'] : un utilisateur de la bse
      // $dDSN['mdp'] : son mot de passe
      
      // cre dans $oDB une connexion  la base dfinie par $dDSN sous l'identit de $dDSN['user']
      // si la connexion russit  
      	// met dans $sDSN la chane de connexion  la base
      	// met dans $sDataBase le nom de la base  laquelle on se connecte
        // met $connect  vrai
      // si la connexion choue
      	// met les msg d'erreurs adquats dans la liste $aErreurs
        // ferme la connexion si besoin est
        // met $connect  faux 
                   
      // raz liste des erreurs
			$this->aErreurs=array();
      
      // on cre une connexion  la base $sDSN
      $this->sDSN=$dDSN["sgbd"]."://".$dDSN["user"].":".$dDSN["mdp"]."@".$dDSN["host"]."/".$dDSN["database"];
      $this->sDatabase=$dDSN["database"];
      $this->connect();
      
      // connect ?
      if( ! $this->connect) return;
     
      // la connexion a russi     
      $this->connect=TRUE;     
    }//constructeur

    // ------------------------------------------------------------------
    function connect(){
    	// (re)connexion  la base
      // raz liste des erreurs
			$this->aErreurs=array();
           
      // on cre une connexion  la base $sDSN
    	$this->oDB=DB::connect($this->sDSN,true);
     
    	// erreur ?
    	if(DB::iserror($this->oDB)){
      	// on note l'erreur
      	$this->aErreurs[]="Echec de la connexion  la base [".$this->sDatabase."] : [".$this->oDB->getMessage()."]";
        // la connexion a chou
        $this->connect=FALSE;
        // fin
        return;
      }
      
      // on est connect
      $this->connect=TRUE;
    }//connect
    
    // ------------------------------------------------------------------
    function disconnect(){
      // si on est connect, on ferme la connexion  la base $sDSN
    	if($this->connect){
  			$this->oDB->disconnect();
      	// on est dconnect
        $this->connect=FALSE;
			}//if
    }//disconnect
    
    // -------------------------------------------------------------------
    function execute($sQuery){
    	// $sQuery : requte  excuter
      
    	// on mmorise la requte
			$this->sQuery=$sQuery;    

      // est-on connect ?
      if(! $this->connect){
      	// on note l'erreur
        $this->aErreurs[]="Pas de connexion existante  la base [$this->sDatabase]";
        // fin
        return;
      }//if
      
      // excution de la requte
      $this->oRsultats=$this->oDB->query($sQuery);
      
    	// erreur ?
    	if(DB::iserror($this->oRsultats)){
    		// on note l'erreur
    		$this->aErreurs[]="Echec de la requte [$sQuery] : [".$this->oRsultats->getMessage()."]";
      	// retour
        return;
      }//if     
    }//execute

    // ------------------------------------------------------------------
    function getData(){
      // on rcupre les 3 sries de donnes limites, coeffr, coeffn
      $this->execute('select limites, coeffR, coeffN from impots');
      // des erreurs ?
      if(count($this->aErreurs)!=0) return array();
      // on parcourt le rsultat du select
      while ($ligne = $this->oRsultats->fetchRow(DB_FETCHMODE_ASSOC)) {
        $limites[]=$ligne['limites'];
        $coeffr[]=$ligne['coeffR'];
        $coeffn[]=$ligne['coeffN'];                
      }//while
      return array($limites,$coeffr,$coeffn);      
    }//getDataImpots

    //--------------------------------------------------------------------
    function dump($dInfos){
    	// affiche un dictionnaire d'informations
      while(list($cl,$valeur)=each($dInfos)){
      	echo "[$cl,$valeur]\n";
      }//while
    }//dump
  }//classe
?>
